/* 

   simple tpoly-to-obj converter -   6/14/93 by Francisco X DeJesus

   dejesus@c3ot.saic.com     -    dejesus@avalon.chinalake.navy.mil

   (written under SunOS 4.1.3... tweaks may be necessary for the
    date/time stuff to work, but it is not crucial, so they can be
    commented out and a fake date hard-coded if neccesary).

   This program is provided "as-is" (ie: use it at your own risk!).
   Permission is hereby granted to redistribute this program freely,
   provided that this header is left unmodified. If you find any bugs or
   modify the program to improve it in any way, please let me know...

   If you have any interesting 3D objects/models, in any format, please
   upload them to the anonymous ftp archive avalon.chinalake.navy.mil!!!

*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <time.h>
#include <sys/time.h>
#include <strings.h>

static char *months[]=
   {
   "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
   };

static char *days[]=
   {
   "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
   };

main(argc,argv)
int argc;
char *argv[];
{
    FILE *fp;
    struct timeval now;
    struct timezone zone;
    time_t then;
    struct tm *t;
    char infilename[40];
    int i, v, vtotal, faces;
    float x,y,z;
    char *progname, *filename;
    char  buf[128];

    while(--argc) {
        argv++;
        if(argv[0][0] != '-')
            break;
        switch(argv[0][1]) {
        case 'h':
        case 'H':
        default:
            fprintf(stderr,"TPOLY to Wavefront OBJ translator\n");
            fprintf(stderr,"usage: tpoly2obj TPOLY-file\n");
            exit();
            break;
        }
    }

    if(argc > 1) {
        fprintf(stderr,"TPOLY to Wavefront OBJ translator\n");
        fprintf(stderr,"usage: tpoly2obj TPOLY-file\n");
        exit(1);
    }
    else if(argc == 1)
        filename = argv[0];
    else
        filename = "stdin";

    if(strcmp(filename, "stdin") != 0) {
        if ((fp = fopen(filename, "r")) == NULL) {
            fprintf(stderr,"failed to open input file for reading");
            exit(1);
        }
    }
    else
        fp = stdin;

    vtotal=0;

        if (gettimeofday(&now,&zone)<0)
                perror("gettimeofday failed"), exit(2);

        if ((t=localtime(&now))==NULL)
                perror("localtime failed"), exit(3);

        if (t->tm_mday > 9)
                fprintf(stdout,"# %s %s %2.2d %2.2d:%2.2d:%2.2d %4.4d\n",
                       days[t->tm_wday],months[t->tm_mon],t->tm_mday,
                       t->tm_hour,t->tm_min,t->tm_sec,
                       (1900+t->tm_year));
        if (t->tm_mday < 10)
                fprintf(stdout,"# %s %s  %d %2.2d:%2.2d:%2.2d %4.4d\n",
                        days[t->tm_wday],months[t->tm_mon],t->tm_mday,
                        t->tm_hour,t->tm_min,t->tm_sec,
                        (1900+t->tm_year));

    fprintf(stdout,"#\n");
    fprintf(stdout,"# Object converted by tpoly2obj\n",infilename);
    fprintf(stdout,"#\n\n");
    fprintf(stdout,"g\n");

    printf("Starting conversion...\n");

    while (!feof(fp))
        {
	    fscanf(fp,"%d",&v);
	    if (v != 3) {
	           break;
	      }
	    vtotal++;
	    v=0;

/* three vertices because each face is a triangle */

	    fscanf(fp,"%f %f %f",&x,&y,&z);
	    fprintf(stdout,"v %f %f %f\n",x,y,z);

	    fscanf(fp,"%f %f %f",&x,&y,&z);
	    fprintf(stdout,"v %f %f %f\n",x,y,z);

	    fscanf(fp,"%f %f %f",&x,&y,&z);
	    fprintf(stdout,"v %f %f %f\n",x,y,z);
        }

    faces=vtotal;
    vtotal=vtotal*3;

    printf("%d vertices\n",vtotal);

    fprintf(stdout,"# %d vertices\n\n",vtotal);

    fprintf(stdout,"# 0 texture vertices\n\n");

    fprintf(stdout,"# 0 normals\n\n");

    fprintf(stdout,"g default\n");


    for (i=0;i<faces;i++) {
      v=i*3;
      fprintf (stdout,"f %d %d %d\n",(v+1),(v+2),(v+3));
    }

    fprintf(stdout,"# %d elements\n\n",faces);

    fclose(fp);
    fclose(stdout);
}
