
#include "xpex.h"
#include <stdio.h>

extern PEXDepthCueEntry depth_cue_entry;


void printDepthCue()
{
    fprintf( stdout, "Depth Cue BP %.2f FP %.2f BS %.2f FS %.2f\n", depth_cue_entry.back_plane, depth_cue_entry.front_plane, depth_cue_entry.back_scaling, depth_cue_entry.front_scaling );

    fprintf( stdout, "Depth Cue Color " );
    switch( depth_cue_entry.color.type ) {
    case PEXColorTypeRGB:
        fprintf( stdout, "RGB %.2f %.2f %.2f ", depth_cue_entry.color.value.rgb.red, depth_cue_entry.color.value.rgb.green, depth_cue_entry.color.value.rgb.blue );
        break;
    case PEXColorTypeHSV:
        fprintf( stdout, "HSV %.2f %.2f %.2f ", depth_cue_entry.color.value.hsv.hue, depth_cue_entry.color.value.hsv.saturation, depth_cue_entry.color.value.hsv.value );
        break;
    case PEXColorTypeHLS:
        fprintf( stdout, "HLS %.2f %.2f %.2f ", depth_cue_entry.color.value.hls.hue, depth_cue_entry.color.value.hls.lightness, depth_cue_entry.color.value.hls.saturation );
        break;
    case PEXColorTypeCIE:
        fprintf( stdout, "CIE %.2f %.2f %.2f ", depth_cue_entry.color.value.cie.x, depth_cue_entry.color.value.cie.y, depth_cue_entry.color.value.cie.z );
        break;
    default:
        break;
    }
    fprintf( stdout, "\n" );
}
